"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.toResponse = exports.toRequest = void 0;
function toRequest(event, context) {
    var _a;
    var body;
    try {
        body = JSON.parse(event.body);
    }
    catch (e) {
        body = event.body;
    }
    var query = Object.keys((_a = event.queryStringParameters) !== null && _a !== void 0 ? _a : {})
        .map(function (key) {
        var _a;
        var _b;
        var isMultiValue = ((_b = event.multiValueQueryStringParameters[key]) === null || _b === void 0 ? void 0 : _b.length) > 1;
        var value = isMultiValue
            ? event.multiValueQueryStringParameters[key]
            : event.queryStringParameters[key];
        return _a = {}, _a[key] = value, _a;
    })
        .reduce(function (previousValue, currentValue) { return (__assign(__assign({}, previousValue), currentValue)); }, {});
    return {
        method: event.httpMethod,
        path: event.path,
        body: body,
        pathParameters: event.pathParameters,
        query: query,
        headers: event.headers,
        locals: {},
        getHeader: function (path) {
            var _a;
            return event.headers[path] ||
                ((_a = Object.entries(event.headers).find(function (_a) {
                    var key = _a[0];
                    return key.toLowerCase() === path.toLowerCase();
                })) === null || _a === void 0 ? void 0 : _a[1]);
        },
        event: event,
        context: context,
    };
}
exports.toRequest = toRequest;
function toResponse(callback) {
    return {
        _headers: {},
        _status: 200,
        _body: null,
        sent: false,
        header: function (key, value) {
            this._headers[key] = value;
            return this;
        },
        status: function (status) {
            this._status = status;
            return this;
        },
        body: function (body) {
            this._body = body;
            return this;
        },
        send: function (body) {
            this.callback(null, {
                headers: Object.keys(this._headers).length > 0 ? this._headers : undefined,
                statusCode: this._status,
                body: body || this._body,
            });
        },
        callback: function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            if (this.sent)
                throw new Error('already sent response');
            this.sent = true;
            return callback.apply(void 0, args);
        },
    };
}
exports.toResponse = toResponse;
