"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.extend = exports.baseExtend = exports.commons = void 0;
var helpers_1 = require("../helpers");
var _commonOptions = {};
exports.commons = {
    configure: function (options) {
        _commonOptions = options;
        // common initialization
        (_commonOptions === null || _commonOptions === void 0 ? void 0 : _commonOptions.initialize) && (_commonOptions === null || _commonOptions === void 0 ? void 0 : _commonOptions.initialize());
    },
};
exports.baseExtend = helpers_1.lambda.extend;
function extend(optionsOrHandler, handler) {
    var _a, _b;
    var options;
    if (typeof optionsOrHandler === 'function') {
        handler = optionsOrHandler;
        options = {};
    }
    else {
        options = optionsOrHandler;
    }
    if (!handler) {
        throw new Error('missing handler');
    }
    var handlerOptions = {
        initialize: function () {
            // handler specific initialization
            (options === null || options === void 0 ? void 0 : options.initialize) && (options === null || options === void 0 ? void 0 : options.initialize());
        },
        middlewares: __spreadArray(__spreadArray([], ((_a = _commonOptions === null || _commonOptions === void 0 ? void 0 : _commonOptions.middlewares) !== null && _a !== void 0 ? _a : [])), ((_b = options.middlewares) !== null && _b !== void 0 ? _b : [])),
    };
    return helpers_1.lambda.extend(handlerOptions, handler);
}
exports.extend = extend;
